//$DDDASD  JOB (001),'INSTALL DDDASD UTIL',CLASS=A,MSGCLASS=X           00010000
//$DDDASD EXEC ASMFCL,PARM.ASM='LOAD,NODECK,LIST,NOXREF',               00020000
//             MAC1='SYS1.AMODGEN'                                      00030000
//ASM.SYSIN DD *                                                        00040000
        TITLE  'GENERATE DD CARDS FOR ONLINE DASD'                      00050000
* ------------------------------------------------------------------- * 00060000
* GENERATES DD JCL STATEMENTS FROM ALL ONLINE, NON-VIRTUAL DASD       * 00070000
* ------------------------------------------------------------------- * 00080000
DDDASD   CSECT                                                          00090000
         USING *,R15                   TEMPORARY BASE                   00100000
         B     #INTRO(,R15)            BRANCH AROUND CONSTANTS          00110000
         DC    AL1(8),CL8'DDDASD'      PROVIDE EYECATCHER               00120000
         DC    CL34'GENERATE DD CARDS FOR ONLINE DASD '                 00130000
         DC    CL16'&SYSDATE @ &SYSTIME'                                00140000
SAVEAREA DC    18F'0'                  MY SAVE AREA                     00150000
#INTRO   EQU   *-DDDASD                                                 00160000
         STM   R14,R12,12(R13)         SAVE CALLER'S REGISTERS          00170000
         LR    R12,R15                 SET BASE REGISTER                00180000
         DROP  R15                                                      00190000
         USING DDDASD,R12                                               00200000
         LA    R2,SAVEAREA             ADDRESS OF SAVE AREA             00210000
         LR    R14,R13                 COPY OLD SAVE AREA ADDRESS       00220000
         LR    R13,R2                  SET NEW SAVE AREA ADDRESS        00230000
         ST    R14,4(,R13)             BACK CHAIN SAVE AREA             00240000
         ST    R13,8(,R14)             FWD CHAIN SAVE AREA              00250000
         LM    R15,R2,16(R14)          RESTORE ENTRY REGISTERS          00260000
         XR    R14,R14                 RESET RETURN ADDRESS             00270000
         OPEN (SYSUT1,(OUTPUT))        OPEN OUTPUT DATASET              00280000
         L     R4,16                   R4->CVT                          00290000
         L     R4,40(,R4)              R4->UCB LOOKUP LIST              00300000
* ------------------------------------------------------------------- * 00310000
* UCB SCAN LOOP                                                       * 00320000
* ------------------------------------------------------------------- * 00330000
UCBSCAN  DS    0H                                                       00340000
         LH    R5,0(,R4)               R5->UCB ADDRESS                  00350000
         LTR   R5,R5                   VALID UCB ADDRESS?               00360000
         BZ    UCBNEXT                   NOT UCB                        00370000
         BM    UCBDONE                   END OF LIST                    00380000
         USING UCBOB,R5                                                 00390000
         TM    UCBID,UCBSTND           CHECK FOR UCB ID                 00400000
         BNO   UCBDONE                   SOMETHING WRONG, EXIT          00410000
         TM    UCBDVCLS,UCB3DACC       IS IT DIRECT ACCESS?             00420000
         BNO   UCBNEXT                   NO, SKIP IT                    00430000
         TM    UCBTBYT2,UCBRVDEV       IS IT A VIRTUAL DEVICE?          00440000
         BO    UCBNEXT                   YES, SKIP IT                   00450000
         TM    UCBSTAT,UCBONLI         IS IT ONLINE?                    00460000
         BNO   UCBNEXT                   NO, SKIP IT                    00470000
         MVC   DDNAME,UCBVOLI          MOVE SERIAL TO DD NAME           00480000
         MVC   DDVOL,UCBVOLI           MOVE SERIAL TO DD VOLSER         00490000
         PUT   SYSUT1,OUTREC           WRITE SYSUT1 RECORD              00500000
UCBNEXT  DS    0H                                                       00510000
         LA    R4,2(,R4)               R4->NEXT ENTRY                   00520000
         B     UCBSCAN                 GO PROCESS                       00530000
* ------------------------------------------------------------------- * 00540000
* END OF UCB'S                                                          00550000
* ------------------------------------------------------------------- * 00560000
UCBDONE  DS    0H                                                       00570000
         CLOSE (SYSUT1)                                                 00580000
         XR    R15,R15                 SET RETURN CODE (0)              00590000
         L     R13,4(,R13)             RESTORE PREVIOUS SAVE AREA       00600000
         ST    R15,16(,R13)            SAVE RETURN CODE                 00610000
         LM    R14,R12,12(R13)         RESTORE CALLER'S REGISTERS       00620000
         BR    R14                     RETURN TO CALLER                 00630000
*                                                                       00640000
* ------------------------------------------------------------------- * 00650000
SYSUT1   DCB   DDNAME=SYSUT1,DSORG=PS,MACRF=PM                          00660000
OUTREC   DS    0CL80                                                    00670000
*                   0....5...10...15...20...25...30...35...40..3        00680000
         DC    CL50'//VVVVVV   DD  UNIT=SYSDA,DISP=OLD,VOL=SER=VVVVVV'  00690000
         DC    CL30'* DDDASD GENERATED'                                 00700000
DDNAME   EQU   OUTREC+2,6,C'C'                                          00710000
DDVOL    EQU   OUTREC+43,6,C'C'                                         00720000
* ------------------------------------------------------------------- * 00730000
         LTORG                                                          00740000
         DSECT                                                          00750000
         IEFUCBOB                                                       00760000
R0       EQU   0                                                        00770000
R1       EQU   1                                                        00780000
R2       EQU   2                                                        00790000
R3       EQU   3                                                        00800000
R4       EQU   4                                                        00810000
R5       EQU   5                                                        00820000
R6       EQU   6                                                        00830000
R7       EQU   7                                                        00840000
R8       EQU   8                                                        00850000
R9       EQU   9                                                        00860000
R10      EQU   10                                                       00870000
R11      EQU   11                                                       00880000
R12      EQU   12                                                       00890000
R13      EQU   13                                                       00900000
R14      EQU   14                                                       00910000
R15      EQU   15                                                       00920000
         END                                                            00930000
//LKED.SYSLMOD DD DSN=SYS2.LINKLIB,DISP=SHR    <==TARGET LIBRARY        00940000
//LKED.SYSIN DD *                                                       00950000
  NAME DDDASD(R)                                                        00960000
//                                                                      00970000
